/* duni.f -- translated by f2c (version 19971204).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

doublereal duni_0_(n__, iseed, kk)
int n__;
integer *iseed, *kk;
{
    /* Initialized data */

    static doublereal u[17] = { .471960981577884755837789724978,
	    .930323453205669578433639632431,.110161790933730836587127944899,
	    .057150199627313951836263875701,.402467554779738266237538503137,
	    .451181953427459489458279456915,.296076152342721102174129954053,
	    .0128202189325888116466879622359,.314274693850973603980853259266,
	    .00335521366752294932468163594171,.48868504520043937160785036784,
	    .195470426865656758693860613516,.864162706791773556901599326053,
	    .335505955815259203596381170316,.377190200199058085469526470541,
	    .400780392114818314671676525916,.374224214182207466262750307281 };
    static integer i__ = 17;
    static integer j = 5;
    static integer k = 47;
    static doublereal c__ = .065104166666593244;

    /* System generated locals */
    integer i__1;
    doublereal ret_val;

    /* Local variables */
    static doublereal s, t;
    static integer i1, j1, k1, l1, m1, ii, jj;

/* ***BEGIN PROLOGUE  DUNI */
/* ***DATE WRITTEN   880714 (YYMMDD) */
/* ***REVISION DATE  880714 (YYMMDD) */
/* ***CATEGORY NO.  L6A21 */
/* ***KEYWORDS  RANDOM NUMBERS, UNIFORM RANDOM NUMBERS */
/* ***AUTHOR    KAHANER, DAVID, SCIENTIFIC COMPUTING DIVISION, NBS */
/*             MARSAGLIA, GEORGE, SUPERCOMPUTER RES. INST., FLORIDA ST. U. */

/* ***PURPOSE  THIS ROUTINE GENERATES DOUBLE PRECISION UNIFORM */
/*             RANDOM NUMBERS ON [0,1) */
/* ***DESCRIPTION */
/*        COMPUTES DOUBLE PRECISION UNIFORM NUMBERS ON [0,1). */
/*           FROM THE BOOK, "NUMERICAL METHODS AND SOFTWARE" BY */
/*                D. KAHANER, C. MOLER, S. NASH */
/*                PRENTICE HALL, 1988 */

/*       USAGE: */
/*              TO INITIALIZE THE GENERATOR */
/*                   USEED = DUSTAR(ISEED) */
/*               WHERE: ISEED IS ANY NONZERO INTEGER */
/*                  WILL RETURN FLOATING POINT VALUE OF ISEED. */

/*               SUBSEQUENTLY */
/*                       U = DUNI() */
/*                  WILL RETURN A REAL UNIFORM ON [0,1) */

/*                ONE INITIALIZATION IS NECESSARY, BUT ANY NUMBER OF EVALUATIONS */
/*                  OF DUNI IN ANY ORDER, ARE ALLOWED. */

/*           NOTE: DEPENDING UPON THE VALUE OF K (SEE BELOW), THE OUTPUT */
/*                       OF DUNI MAY DIFFER FROM ONE MACHINE TO ANOTHER. */

/*           TYPICAL USAGE: */

/*               DOUBLE PRECISION U,DUNI,DUSTAR,USEED */
/*               INTEGER ISEED */
/* C                 SET SEED */
/*               ISEED = 305 */
/*               USEED = DUSTAR(ISEED) */
/*               DO 1 I = 1,1000 */
/*                   U = DUNI() */
/*             1 CONTINUE */
/* C                 NOTE: IF K=47 (THE DEFAULT, SEE BELOW) THE OUTPUT VALUE OF */
/* C                           U WILL BE 0.812053811384E-01... */
/*               WRITE(*,*) U */
/*               END */

/*          NOTE ON PORTABILITY: USERS CAN CHOOSE TO RUN DUNI IN ITS DEFAULT */
/*               MODE (REQUIRING NO USER ACTION) WHICH WILL GENERATE THE SAME */
/*               SEQUENCE OF NUMBERS ON ANY COMPUTER SUPPORTING FLOATING POINT */
/*               NUMBERS WITH AT LEAST 47 BIT MANTISSAS, OR IN A MODE THAT */
/*               WILL GENERATE NUMBERS WITH A LONGER PERIOD ON COMPUTERS WITH */
/*               LARGER MANTISSAS. */
/*          TO EXERCISE THIS OPTION:  B E F O R E  INVOKING DUSTAR INSERT */
/*               THE INSTRUCTION        UBITS = DUNIB(K)      K >= 47 */
/*               WHERE K IS THE NUMBER OF BITS IN THE MANTISSA OF YOUR FLOATING */
/*               POINT WORD (K=96 FOR CRAY, CYBER 205). DUNIB RETURNS THE */
/*               FLOATING POINT VALUE OF K THAT IT ACTUALLY USED. */
/*                    K INPUT AS .LE. 47, THEN UBITS=47. */
/*                    K INPUT AS .GT. 47, THEN UBITS=FLOAT(K) */
/*               IF K>47 THE SEQUENCE OF NUMBERS GENERATED BY DUNI MAY DIFFER */
/*               FROM ONE COMPUTER TO ANOTHER. */



/* ***REFERENCES  MARSAGLIA G., "COMMENTS ON THE PERFECT UNIFORM RANDOM */
/*                 NUMBER GENERATOR", UNPUBLISHED NOTES, WASH S. U. */
/* ***ROUTINES CALLED  (NONE) */
/* ***END PROLOGUE DUNI */
/*                            2**47=0.140737488355328D+15 */

/*      LOAD DATA ARRAY IN CASE USER FORGETS TO INITIALIZE. */
/*      THIS ARRAY IS THE RESULT OF CALLING DUNI 100000 TIMES */
/*         WITH ISEED=305 AND K=96. */
    switch(n__) {
	case 1: goto L_dustar;
	case 2: goto L_dunib;
	}


/*   BASIC GENERATOR IS FIBONACCI */

    ret_val = u[i__ - 1] - u[j - 1];
    if (ret_val < 0.) {
	ret_val += 1.;
    }
    u[i__ - 1] = ret_val;
    --i__;
    if (i__ == 0) {
	i__ = 17;
    }
    --j;
    if (j == 0) {
	j = 17;
    }

/*   SECOND GENERATOR IS CONGRUENTIAL */

    c__ += -.54387223503964321;
    if (c__ < 0.) {
	c__ += .99999999999918288;
    }

/*   COMBINATION GENERATOR */

    ret_val -= c__;
    if (ret_val < 0.) {
	ret_val += 1.;
    }
    return ret_val;


L_dustar:

/*          SET UP ... */
/*          CONVERT ISEED TO FOUR SMALLISH POSITIVE INTEGERS. */

    i1 = abs(*iseed) % 177 + 1;
    j1 = abs(*iseed) % 167 + 1;
    k1 = abs(*iseed) % 157 + 1;
    l1 = abs(*iseed) % 147 + 1;

/*              GENERATE RANDOM BIT PATTERN IN ARRAY BASED ON GIVEN SEED. */

    for (ii = 1; ii <= 17; ++ii) {
	s = 0.;
	t = .5;
/*             DO FOR EACH OF THE BITS OF MANTISSA OF WORD */
/*             LOOP  OVER K BITS, WHERE K IS DEFAULTED TO 47 BUT CAN */
/*               BE CHANGED BY USER CALL TO DUNIB(K) */
	i__1 = k;
	for (jj = 1; jj <= i__1; ++jj) {
	    m1 = i1 * j1 % 179 * k1 % 179;
	    i1 = j1;
	    j1 = k1;
	    k1 = m1;
	    l1 = (l1 * 53 + 1) % 169;
	    if (l1 * m1 % 64 >= 32) {
		s += t;
	    }
/* L3: */
	    t *= .5;
	}
/* L2: */
	u[ii - 1] = s;
    }
    ret_val = (real) (*iseed);
    return ret_val;


L_dunib:
    if (*kk <= 47) {
	k = 47;
    } else {
	k = *kk;
    }
    ret_val = (real) k;
    return ret_val;
} /* duni_ */

doublereal duni_()
{
    return duni_0_(0, (integer *)0, (integer *)0);
    }

doublereal dustar_(iseed)
integer *iseed;
{
    return duni_0_(1, iseed, (integer *)0);
    }

doublereal dunib_(kk)
integer *kk;
{
    return duni_0_(2, (integer *)0, kk);
    }

