%module _global1
%include typemaps.i
%{
#include "Python.h"
#include "arrayobject.h"
#include "callback.h"
#include "globdef.h"
%}

%typemap(python, in) S_fp f {
  $target = (S_fp)((callback_getCallbackFn)($source));
  if ($target==NULL) return NULL;
}

%typemap(python, in) FILE * {
  if (!PyFile_Check($source)) {
    PyErr_SetString(PyExc_TypeError, "Need a file!");
    return NULL;
  }
  $target = PyFile_AsFile($source);
}

%typemap(python,in) VEKTOR_n {
  /* VECTOR */
  PyArrayObject *arr;
  arr = (PyArrayObject *) $source;
  if ( !(PyArray_Check(arr)) ||
       (arr->descr->type_num != PyArray_DOUBLE) ||
       arr->nd != 1 || !PyArray_ISCONTIGUOUS(arr) ) {
     PyErr_SetString(PyExc_TypeError,"Argument must be a 1d double contiguous NumPy array.");
     return NULL;
  }
  $target = (VEKTOR_n)arr->data;
}

%typemap(python,in) TOMB_nx21 {
  /* typedef double array[m][n]; */
  PyArrayObject *ap;
  /* Recast like this will not increase ref count */
  ap = (PyArrayObject *) $source;
  if ( !(PyArray_Check(ap)) ||
       (ap->descr->type_num != PyArray_DOUBLE) ||
       ap->nd != 2 || !PyArray_ISCONTIGUOUS(ap) ) {
     PyErr_SetString(PyExc_TypeError,"Argument must be a 2d double contiguous NumPy array.");
     return NULL;
  }
  $target = (TOMB_nx21)ap->data;
}

%init %{
import_array();
import_callback();
%}

typedef /* Subroutine */ void (*S_fp)();
typedef double *VEKTOR_n;
typedef TOMBnx21 *TOMB_nx21;
extern int GLOBAL(S_fp f, VEKTOR_n, VEKTOR_n, int *INPUT, int *INPUT,
		  int *INPUT, int *INPUT, FILE *, int *INPUT,
		  TOMB_nx21, int *OUTPUT, VEKTOR_n, int *OUTPUT);

