/* Initial release, M Xu, 3/20/99 */
#define BUF_SIZE 10

typedef struct 
{
    char name[32];
    char des[128];
    /* a python callback pointer, is NULL when a C/Fortran callback is
     used */
    PyObject *pyfn;
    /* the C/Fortran callback or C wrapper for a python callback */
    void *fp;
} userfunc;

/* userfn_NameList() returns a python dictionary.  The dictionary should
 * help explain the function to index mapping and give a brief
 * description of the functions
 *
 * userfn_NameList:  name --> (index, des)
 *
 */
extern PyObject *userfn_NameList();
      
/* stores the C/Fortran callbacks or wrappers for Python callbacks,
 * defined in userfn.c
 */
extern userfunc *userfn[BUF_SIZE]; 

/* used in callback module itself */
#ifdef CALLBACK_MODULE
#define callback_API_pointers 1

/* client calls this to get a suitable pointer to 
 * a C/Fortran callback or a wrapper for Python callback 
 */ 
extern void *getCallbackFn(PyObject *cb);

/* used in clients of callback module */
#else
static void **callback_API;

#define callback_getCallbackFn \
  (*(void *(*)Py_PROTO((PyObject *cb))) callback_API[0])

#define import_callback() \
{ \
  PyObject *module = PyImport_ImportModule("_callback"); \
  if (module != NULL) { \
    PyObject *module_dict = PyModule_GetDict(module); \
    PyObject *c_api_object = PyDict_GetItemString(module_dict, "_C_API"); \
    if (PyCObject_Check(c_api_object)) { \
      callback_API = (void **)PyCObject_AsVoidPtr(c_api_object); \
    } \
  } \
} 

#endif
