import callback, _sigma, sys, MLab
def wrap(x):
    xargs = list(extra_args)
    xargs.insert(0, x)
    return apply(funct, tuple(xargs))

def SIGMA(f, x0, xargs=(), nsuc=3, iprint=0):
    " [fmin, xmin, nfeval] = SIGMA(f, x0, xargs=(), nsuc=3, iprint=0) returns the most likely global minimum with the number of evaluations in nfeval. \nx is unconstraited and x0 is the initial guess. Python function f accepts an array x and possible xargs as its arguments, and return a double value. \niprint controls the levels of output, iprint <0 no output, =0 normal, >0 verbose " 
    
    x0 = MLab.array(x0, 'd')
    n = len(x0)
    xmin = MLab.zeros(n, 'd')

    # make a callback
    if len(xargs) == 0:
        cb = callback.callback(f, 'SIGMA')
    else:
        global funct, extra_args
        funct=f; extra_args = xargs
        cb = callback.callback(wrap, 'SIGMA')

    [fmin, nfeval, iout] = _sigma.sigma1_f(cb, n, x0, nsuc, iprint, xmin)

    # cleanup and return
    if iout <= 0:
        print 'SIGMA1 failed\n' 
        return None
    if n == 1: xmin = xmin[0]
    return [fmin, xmin, nfeval]
