      SUBROUTINE ALKNUT(NREM,X,IREM)
C
C UPDATES THE COMPONENT IREM OF THE NREM-VECTOR X WITH A RANDOM NUMBER
C UNIFORMLY DISTRIBUTED IN (0,1) BY MEANS OF THE ALGORITHM
C OF MITCHELL-MOORE, MODIFIED AS SUGGESTED BY BRENT, QUOTED IN
C D.E.KNUTH, THE ART OF COMPUTER PROGRAMMING, SECOND EDITION,
C SECOND VOLUME, SEMINUMERICAL ALGORITHMS, ADDISON-WESLEY
C PUB. CO., READING (1981), PP. 26-28.
C
      DOUBLE PRECISION X
C
      DIMENSION X(NREM)
C
      DATA N1,N2/24,55/
C
      IF(IREM.NE.0) GO TO 10
C
      IREM = NREM
      I1 = NREM-N1
      I2 = NREM-N2
C
  10  CONTINUE
C
      X(IREM) = DMOD(X(I1)+X(I2),1.D0)
C
      IREM = 1+MOD(IREM,NREM)
      I1 = 1+MOD(I1,NREM)
      I2 = 1+MOD(I2,NREM)
C
      RETURN
      END
