      DOUBLE PRECISION FUNCTION EIGSCA(COR)
C
C  EIGSCA COMPUTES THE LARGEST EIGENVALUE OF A MATRIX USED FOR RESCA-
C  LING, STARTING FROM A RANDOMLY-CHOSEN ESTIMATE (OBTAINED BY CALLING
C  THE SUBROUTINE  UNITRV ) OF THE CORRESPONDING EIGENVECTOR
C
      DOUBLE PRECISION COR
      DOUBLE PRECISION ALA1,ALA1I,ALA1O
      DOUBLE PRECISION PREC,SWW,W,WW
      DOUBLE PRECISION DIST,BIAS,GRAGRA,GRA
      COMMON /SCALE/ DIST(10,10,20),BIAS(10,20),GRAGRA(10,10,20),
     1    GRA(10,20),NGRA(20),LSCA,IDSCA,NX,NORD
      DIMENSION COR(10,10)
      DIMENSION W(10),WW(10)
      DATA PREC /1.D-3/
      DATA NRMIN /10/
      DATA NRMAX /100/
C
      CALL UNITRV(NX,W)
      ALA1 = 0.D0
      DO 1 IR = 1,NRMAX
         ALA1O = ALA1
         SWW = 0.D0
         DO 2 IX = 1,NX
            WW(IX) = 0.D0
            DO 3 JX = 1,NX
               WW(IX) = WW(IX)+COR(IX,JX)*W(JX)
   3           CONTINUE
            SWW = SWW+WW(IX)**2
   2        CONTINUE
         ALA1 = DSQRT(SWW)
         ALA1I = 1.D0/ALA1
         IF(IR.GE.NRMIN.AND.ALA1*PREC.GT.DABS(ALA1-ALA1O))GO TO 4
         DO 5 IX = 1,NX
            W(IX) = WW(IX)*ALA1I
   5        CONTINUE
   1     CONTINUE
   4  CONTINUE
      EIGSCA = ALA1
C
      RETURN
      END
