      SUBROUTINE GENEVA(NX,XMIN,FMIN,FMAX,NCEF)
C
C  GENEVA  PERFORMS THE GENERATION AND THE FINAL PROCESSING AND
C  EVALUATION OF THE SET OF TRAJECTORY SEGMENTS CORRESPONDING TO
C  THE CURRENT OBSERVATION PERIOD.
C  GENEVA  UPDATES THE SCALING ARRAYS  DIST  AND  BIAS  BY CALLING
C             THE SUBROUTINES  SEGSCA  AND  UPDSCA
C          GENERATES THE TRAJECTORY SEGMENTS BY CALLING THE SUB-
C             ROUTINE  PERIOD
C          DETERMINES SOME END-OF-SEGMENT RESULTS  (FPFMIN, FPFMAX,
C             XPFMIN)  USING THE RESCALING CAPABILITIES OF THE SUB-
C             ROUTINES  SEGSCA  AND  VARSCA.
C
      DOUBLE PRECISION XMIN,FMIN,FMAX
      DOUBLE PRECISION FM
      DOUBLE PRECISION X,H,DX,VMVT,EPS,VMCOR,VCOR
      DOUBLE PRECISION XRMIN,XRMAX,XOPT,FOPT
      COMMON /DINCOM/ X(100,20),H(20),DX(20),VMVT(20,19),EPS(20),
     1    VMCOR(20),VCOR(20),XRMIN(100),XRMAX(100),XOPT(100),FOPT,
     2    IE(20),ISVT(20,19),KGEN,KTIM,NDIM,NTRAJ,NTRAJR,
     3    ISEGBR,INKPBR,KPBR0,NCF,IFEP,INHP
      DIMENSION XMIN(NX)
C
C UPDATE SCALING DATA
C
      DO 10 ID = 1,NTRAJ
         CALL SEGSCA(ID)
         CALL UPDSCA(NX,X(1,ID))
  10     CONTINUE
C
C GENERATE THE SIMULTANEOUS TRAJECTORY SEGMENTS
C
      CALL PERIOD
C
C EXTRACT AND RESCALE SOME FINAL VALUES
C
      FM = VCOR(1)
      FMAX = VCOR(1)
      IFM = 1
      DO 30 ID = 2,NTRAJ
         FMAX = DMAX1(FMAX,VCOR(ID))
         IF(VCOR(ID).GE.FM)GO TO 20
         FM = VCOR(ID)
         IFM = ID
  20     CONTINUE
  30     CONTINUE
      DO 40 IC = 1,NDIM
         XMIN(IC) = X(IC,IFM)
  40     CONTINUE
      FMIN = FM
      NCEF = NCF
      CALL SEGSCA(IFM)
      CALL VARSCA(NX,XMIN)
C
      RETURN
      END
