      SUBROUTINE ORDER(IP,IM,IU)
C
C  ORDER  COMPARES THE TRAJECTORIES FROM THE POINT OV VIEW OF PAST
C  HISTORY (BY CALLING THE FUNCTION  IPREC ) AND FROM THE POINT OF VIEW
C  OF THEIR CURRENT VALUE OF  EPS  (BY CALLING THE FUNCTION  IPRECE)
C  AND PROVIDES THE TRAJECTORY ORDERING NEEDED FOR SELECTING THE TRA-
C  JECTORY WHICH IS TO BE BRANCHED.
C
      DOUBLE PRECISION X,H,DX,VMVT,EPS,VMCOR,VCOR
      DOUBLE PRECISION XRMIN,XRMAX,XOPT,FOPT
      COMMON /DINCOM/ X(100,20),H(20),DX(20),VMVT(20,19),EPS(20),
     1    VMCOR(20),VCOR(20),XRMIN(100),XRMAX(100),XOPT(100),FOPT,
     2    IE(20),ISVT(20,19),KGEN,KTIM,NDIM,NTRAJ,NTRAJR,
     3    ISEGBR,INKPBR,KPBR0,NCF,IFEP,INHP
      DIMENSION IORD(20)
      DATA KP/0/
      IR = 0
C
C ASSIGN INITIAL ORDERING
C
  10  CONTINUE
      DO 20 I = 1,NTRAJ
         IORD(I) = I
  20     CONTINUE
C
C SORT TRAJECTORIES ...
C
  30  CONTINUE
      IR = IR+1
C
      DO 60 I = 1,NTRAJR
         I1 = I+1
         DO 50 J = I1,NTRAJ
            K1 = IORD(I)
            K2 = IORD(J)
C
C ... ACCORDING TO PAST HISTORY ...
C
            IF(IR.NE.2)KP = IPREC(K1,K2)
            IF(KP.EQ.0.AND.IR.EQ.1)GO TO 10
C
C ... OR ACCORDING TO NOISE LEVEL
C
            IF(IR.EQ.2)KP = IPRECE(K1,K2)
            IF(KP.EQ.0)GO TO 40
            KM = K1+K2-KP
            IORD(I) = KP
            IORD(J) = KM
  40        CONTINUE
  50        CONTINUE
  60     CONTINUE
      IF(IR.EQ.2)GO TO 30
C
C RETURN THE INDICES OF THE SEGMENTS WHICH IN THE ORDERING
C OCCUPY THE FIRST, THE LAST, AND A SUITABLE MEDIUM LEVEL POSITION
C
      IP = IORD(1)
      IU = IORD(NTRAJ)
      IM = IORD(ISEGBR)
C
      RETURN
      END
