      SUBROUTINE TRIAL(N,NPMIN,NPMAX,KPASCA,
     1    TOLREL,TOLABS,IPRINT,XMIN,FMIN,
     2    FMAX,NFEV,NR,ISTOP)
C
C  THE SUBROUTINE  TRIAL  GENERATES A TRIAL, I.E. A SET OF COMPLETE
C  SIMULTANEOUS TRAJECTORIES BY REPEATEDLY PERFORMING
C     A CALL TO THE SUBROUTINE  GENEVA  WHICH GENERATES THE SET OF
C        SIMULTANEOUS TRAJECTORY SEGMENTS CORRESPONDING TO THE CURRENT
C        OBSERVATION PERIOD, AND PERFORMS THE TRAJECTORY SELECTION
C     A (POSSIBLE) CALL TO THE SUBROUTINE  PTSEG  WHICH PERFORMS
C        END-OF-SEGMENT OUTPUT
C     A CHECK OF THE TRIAL STOPPING CRITERIA (WITH THE AID OF THE
C        FUNCTION  ITOLCH
C     A DECISION ABOUT ACTIVATING OR DEACTIVATING THE SCALING OF
C        THE VARIABLES (ACTIONS PERFORMED BY CALLING THE SUBROUTINES
C        ACTSCA  AND  NOSCA).
C
      DOUBLE PRECISION TOLREL,TOLABS,XMIN,FMIN,FMAX
      DIMENSION XMIN(N)
      DATA IRNF/7/
C
      DO 20 IR = 1,NPMAX
C
C ACTIVATE SCALING
C
         IF(IR.GE.KPASCA.AND.IR.GT.N*IRNF)CALL ACTSCA
         NR = IR
C
C GENERATE AND EVALUATE THE SIMULTANEOUS TRAJECTORY SEGMENTS
C PERIOD
C
         CALL GENEVA(N,XMIN,FMIN,FMAX,NFEV)
C
C PRINT RESULTS OF OBSERVATION PERIOD
C
         IF(IPRINT.GT.0)CALL PTSEG(N,XMIN,FMIN,FMAX,IR,NFEV)
C
C CHECK TRIAL STOPPING CONDITIONS
C
         IF(IR.LT.NPMIN)GO TO 10
         ISTOP = ITOLCH(FMAX,FMIN,TOLREL,TOLABS)
         IF(ISTOP.NE.0)GO TO 30
C
  10     CONTINUE
  20     CONTINUE
  30  CONTINUE
      CALL NOSCA
C
      RETURN
      END
