      SUBROUTINE UPDSCA(N,X)
C
C  UPDSCA  UPDATES THE SCALING MATRIX  A  AND THE BIAS VECTOR  B BY
C  CALLING  EIGSCA  AND  VARSCA
C
      DOUBLE PRECISION X
      DOUBLE PRECISION AGRAI,ALA1,ALPHA,AMCOR,BIAST
      DOUBLE PRECISION CD,COR,DISTT,SN
      DOUBLE PRECISION EIGSCA
      DOUBLE PRECISION DIST,BIAS,GRAGRA,GRA
      COMMON /SCALE/ DIST(10,10,20),BIAS(10,20),GRAGRA(10,10,20),
     1    GRA(10,20),NGRA(20),LSCA,IDSCA,NX,NORD
      DIMENSION X(N)
      DIMENSION DISTT(10,10),BIAST(10),COR(10,10)
      DATA ALPHA /0.3D0/
C
      IF(LSCA.LE.0)RETURN
      ID = IDSCA
      IF(NGRA(ID).LT.2*NX*NX)GO TO 2
      AGRAI = 1.D0/DBLE(FLOAT(NGRA(ID)))
      AMCOR = 0.D0
      DO 3 I = 1,NX
         DO 4 J = 1,NX
         COR(I,J) = AGRAI*GRAGRA(I,J,ID)-AGRAI*GRA(I,ID)*AGRAI*GRA(J,ID)
            AMCOR = DMAX1(AMCOR,DABS(COR(I,J)))
   4        CONTINUE
   3     CONTINUE
      IF(AMCOR.LE.0.D0)GO TO 12
      DO 1 I = 1,NX
         DO 11 J = 1,NX
            COR(I,J) = COR(I,J)/AMCOR
  11        CONTINUE
   1     CONTINUE
      ALA1 = EIGSCA(COR)
      CD = ALA1*(1.D0+ALPHA)
      DO 5 I = 1,NX
         COR(I,I) = COR(I,I)-CD
         BIAST(I) = X(I)
   5     CONTINUE
      CALL VARSCA(NX,BIAST)
      SN = 0.D0
      DO 6 I = 1,NX
         DO 7 J = 1,NX
            DISTT(I,J) = 0.D0
            DO 8 K = 1,NX
               DISTT(I,J) = DISTT(I,J)-DIST(I,K,ID)*COR(K,J)
   8           CONTINUE
            SN = SN+DISTT(I,J)**2
   7        CONTINUE
   6     CONTINUE
      SN = 1.D0/DSQRT(SN/DBLE(FLOAT(NX)))
      DO 9 I = 1,NX
         BIAS(I,ID) = BIAST(I)
         DO 10 J = 1,N
            DIST(I,J,ID) = SN*DISTT(I,J)
            BIAS(I,ID) = BIAS(I,ID)-DIST(I,J,ID)*X(J)
            GRAGRA(I,J,ID) = 0.D0
  10        CONTINUE
         GRA(I,ID) = 0.D0
   9     CONTINUE
      NGRA(ID) = 0
   2  CONTINUE
  12  CONTINUE
C
      RETURN
      END
