%module _sigma
%include typemaps.i
%{
#include "Python.h"
#include "arrayobject.h"
#include "callback.h"
typedef /* function */ double (*U_fp)();
typedef double *VEKTOR_n;
static U_fp fp;
extern double funct_(int *n, double* x) {
    return (*fp)(n, x);
}
extern void sigma1_(int *n, double *x, int *nsuc, int *iprint,
		    double *xmin, double *fmin, int *nfev, int *iout);
static void sigma1_f(U_fp f, int *n, double *x, int *nsuc, int *iprint,
		     double *xmin, double *fmin, int *nfev, int *iout)
{
    fp = f;
    sigma1_(n, x, nsuc, iprint, xmin, fmin, nfev, iout);
}
%}

%typemap(python, in) U_fp f {
  $target = (U_fp)((callback_getCallbackFn)($source));
  if ($target==NULL) return NULL;
}

%typemap(python,in) VEKTOR_n {
  /* VECTOR */
  PyArrayObject *arr;
  arr = (PyArrayObject *) $source;
  if ( !(PyArray_Check(arr)) ||
       (arr->descr->type_num != PyArray_DOUBLE) ||
       arr->nd != 1 || !PyArray_ISCONTIGUOUS(arr) ) {
     PyErr_SetString(PyExc_TypeError,"Argument must be a 1d double contiguous NumPy array.");
     return NULL;
  }
  $target = (VEKTOR_n)arr->data;
}

%init %{
import_array();
import_callback();
%}

typedef /* Subroutine */ double (*U_fp)();
typedef double *VEKTOR_n;
extern void sigma1_f(U_fp f, int *INPUT, VEKTOR_n, int *INPUT, int *INPUT, VEKTOR_n, double *OUTPUT, int *OUTPUT, int *OUTPUT);
    









