      DOUBLE PRECISION FUNCTION UNIFRD(INIZ)
C
C UNIFRD GENERATES THE RANDOM NUMBERS UNIFORMLY DISTRIBUTED IN (0,1)
C EXPLOITING THOSE GENERATED BY  ALKNUT  WITH A FURTHER RANDOMIZATION
C IF THE INPUT PARAMETER INIZ  IS NOT 0
C THE RANDOM NUMBER GENERATOR IS INITIALIZED
C
      DOUBLE PRECISION A,B,C,X
      DOUBLE PRECISION X0,P,P0,P1,P2,R1,R2
      DOUBLE PRECISION FINV
C
      DIMENSION X(61)
C
      DATA NREM/61/,NRIP/100/
      DATA A,B,C/-1.5D0,5.5D0,-2.0D0/
      DATA FINV/3.5D-5/
      DATA IREM/0/
      DATA P0/3.D0/,P1,P2/1.D0,3.D0/,R1,R2/0.25D0,0.75D0/
C
      IF(INIZ.NE.0.OR.IREM.EQ.0) GO TO 10
C
      I0 = IREM
      X0 = X(I0)
C
C NONLINEARIZATION OF X0 TO AVOID LONG-DISTANCE LINEAR RELATIONSHIP.
C
      IF(X0.GE.FINV)X0 = DMOD(1.D0/X0,1.D0)
C
C UPDATE A COMPONENT OF THE VECTOR X ...
C
      CALL ALKNUT(NREM,X,IREM)
C
C ... AND FURTHER RANDOMIZE
C
      UNIFRD = DMOD(X0+X(I0),1.D0)
C
      RETURN
C
C INITIALIZATION OF THE RANDOM NUMBER GENERATOR
C
  10  CONTINUE
C
      P = P0-1.D0/DBLE(FLOAT(IABS(INIZ))+100.0)
      DO 20 K = 1,NREM
C
         P = C+P*(B+P*A)
C
C
         X(K) = R1+(R2-R1)*(P-P1)/(P2-P1)
  20     CONTINUE
C
      IREM = 0
C
      DO 30 K = 1,NRIP
C
         CALL ALKNUT(NREM,X,IREM)
C
  30     CONTINUE
C
      UNIFRD = X(1)
C
      RETURN
      END
